//---------------------------------------------------------------------------

#include <vcl.h>
#include <windows.h>
#include <string.h>

#pragma hdrstop

struct sPluginInfo
{
	char strPluginName[255];
	char strPluginDescription[255];
	char strPluginVersion[255];
};

DWORD dwPluginID;

typedef BYTE __stdcall (*typeClCommFortProcess)(DWORD dwPluginID, DWORD dwMessageID, BYTE * bMessage, DWORD dwMessageLength);
typedef DWORD __stdcall (*typeClGetData)(DWORD dwDataID, BYTE * bBuffer, DWORD dwBufferSize);

typeClCommFortProcess CommFortProcess;
typeClGetData CommFortGetData;

extern "C" __declspec(dllexport) BYTE PluginInit(DWORD dwThisPluginID, sPluginInfo *plInfo, typeClCommFortProcess, typeClGetData);
extern "C" __declspec(dllexport) BYTE PluginTerminate();
extern "C" __declspec(dllexport) BYTE PluginProcess(DWORD dwMessageID, BYTE * bMessage, DWORD dwMessageLength);
extern "C" __declspec(dllexport) VOID PluginShowOptions();
extern "C" __declspec(dllexport) VOID PluginShowAbout();

#pragma argsused

//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
	return 1;
}
//---------------------------------------------------------------------------
BYTE PluginInit(DWORD dwThisPluginID, sPluginInfo *plInfo, typeClCommFortProcess func1, typeClGetData func2)
{
	dwPluginID = dwThisPluginID;
	//    
	//   ,  
	//       

	strcpy((*plInfo).strPluginName,"Null");
	strcpy((*plInfo).strPluginDescription,"Test plugin for CommFort client 4.30");
	strcpy((*plInfo).strPluginVersion,"4.30");
	//    
	//    CommFort client  
	// 

	CommFortProcess = func1;
        //   ,
	//       
	CommFortGetData = func2;
        //   ,
	//         

	return 0;
}
//---------------------------------------------------------------------------
BYTE PluginTerminate()
{
	//      

	return 0;
}
//---------------------------------------------------------------------------
BYTE PluginProcess(DWORD dwMessageID, BYTE * bMessage, DWORD dwMessageLength)
{
	//      
	//:
	//dwMessageID -   
	//bMessage -   
	//dwMessageLength -        

	// :
	//    

	if(dwMessageID==5)
	{
		//   :
		//AnsiString aMessageToSend;
		//(*CommFortProcess)(dwPluginID,20,aMessageToSend.c_str(),aMessageToSend.Length());

		//      :
		//AnsiString aChannel;
		//int iLen = (*CommFortGetData)(11,NULL,NULL);
		//aChannel.SetLength(iLen);
		//(*CommFortGetData)(11,aChannel.c_str(),iLen);
		//ShowMessage(aChannel);
	}

	return 0;
}
//---------------------------------------------------------------------------
VOID PluginShowOptions()
{
	//      ""   

        ShowMessage("Options");
}
//---------------------------------------------------------------------------
VOID PluginShowAbout()
{
	//      " "   

	ShowMessage("Test plugin for CommFort client 4.30\n\nCreated by CommFort software Ltd.");
}
//---------------------------------------------------------------------------


